<?php
/**
 * @file likno_tabs.admin.inc
 * Functions that are only called on the admin pages.
 */

/*This function is used by file_Save_upload to validate the filename of the uploaded file
 */
function likno_tabs_validate_filename($file, $filename) {
  $errors = array();
  // Bypass validation for uid  = 1.
    
    if ($file->filename != "drupal_".$filename.".zip") {
      $errors[] = t('Filename must be : %filename.', array('%filename' => "drupal_".$filename.".zip"));

  }
  return $errors;
}
function likno_tabs_tab_operations() {
  $operations = array(
    'active' => array(
      'label' => t('Activated selected tab controls'),
      'callback' => 'likno_tabs_mass_update',
      'callback arguments' => array('updates' => array('active' => TRUE)),
    ),
    'deactivate' => array(
      'label' => t('Deactivate selected tab controls'),
      'callback' => 'likno_tabs_mass_update',
      'callback arguments' => array('updates' => array('active' => FALSE)),
    ),
    'delete' => array(
      'label' => t('Delete selected tab controls'),
      'callback' => NULL,
    ),
  );
  return $operations;
}

function likno_tabs_mass_update($tabs, $updates) {
  // We use batch processing to prevent timeout when updating a large number
  // of nodes.
  if (count($tabs) > 10) {
    $batch = array(
      'operations' => array(
        array('_likno_tabs_mass_update_batch_process', array($tabs, $updates))
      ),
      'finished' => '_likno_tabs_update_batch_finished',
      'title' => t('Processing'),
      // We use a single multi-pass operation, so the default
      // 'Remaining x of y operations' message will be confusing here.
      'progress_message' => '',
      'error_message' => t('The update has encountered an error.'),
      // The operations do not live in the .module file, so we need to
      // tell the batch engine which file to load before calling them.
      'file' => drupal_get_path('module', 'likno_tabs') . '/likno_tabs.admin.inc',
    );
    batch_set($batch);
  }
  else {
    foreach ($tabs as $id) {
      _likno_tabs_mass_update_helper($id, $updates);
    }
    drupal_set_message(t('The update has been performed.'));
  }
}

function _likno_tabs_mass_update_helper($id, $updates) {
  $tab = tab_load($id);

  foreach ($updates as $name => $value) {
    $tab->$name = $value;
  }
  tab_save($tab);
  return $tab;
}

/* This function unzips a file
 * name: the name of the file to unzip
 * folder: the target location of the unzipped files
 */
function likno_tabs_unzipper($name, $folder){

    if (class_exists('ZipArchive')){
    $zip = new ZipArchive;
     $res = $zip->open($name);
     if ($res === TRUE) {
         if ($zip->extractTo($folder)){
         $zip->close();
         return 1;}
         else{
             
             return 0;

             }
     } else {
         return 0;
     }
    }
     return 0;
}

function likno_tabs_tab_edit($tab) {
   
  drupal_set_title(t('<em>Edit tab control</em> @title', array( '@title' => $tab->name)), PASS_THROUGH);
  
  return drupal_get_form('likno_tabs_tab_form', $tab);
}

function likno_tabs_add() {
  
    return drupal_get_form('likno_tabs_tab_form',null);

  //return theme('node_add_list', array('content' => $content));
}


function likno_tabs_tab_form($form, &$form_state, $tab) {
  global $user;
  global $base_url;
  drupal_add_js(drupal_get_path('module', 'likno_tabs') . '/likno_tabs.js');
  drupal_add_js("ZeroClipboard.setMoviePath( '".$base_url."/".drupal_get_path('module', 'likno_tabs')."/clipboard.swf' );",'inline');
  drupal_add_css('.form-item-position{padding-bottom: 0px!important;margin-bottom: 0px!important;}#lwtb_divname,#lwtb_shortcode{padding: 2px;margin-top: 10px;width: 200px;background-color:#D2D2D2;}#lwtb_shortcode{margin-top: 10px;}#lwtb_copy_button.active,#lwtb_shortcode_button.active{text-decoration: none; background-color:#5a5a5a; background-image:none; color:#D2D2D2;}','inline');
// During initial form build, add the node entity to the form state for use
  // during form building and processing. During a rebuild, use what is in the
  // form state.


  $i = 1;
  if ($tab == null){
  $tab = new stdClass();
  while (true){
  $result = db_query("SELECT name FROM {lwtb_table} WHERE name = :name", array(
  ':name' => "tabcontrol".$i
));
  $name = $result->fetchField();
  if ($name!=null){
      if ($name!="tabcontrol".$i)
          break;
      else
          $i++;
      }
      else
          break;
  }
      $tab->name = "tabcontrol".$i;
      $tab->active = 0;
      $tab->position = "shortcode";
      $tab->print_div = 1;
  }

  if (!isset($form_state['tab'])) {
    if (!isset($tab->name)) {
      $tab->name = NULL;
    }
    $form_state['tab'] = $tab;
  }
  else {
    $tab = $form_state['tab'];
  }


  
  // Basic node information.
  // These elements are just values so they are not even sent to the client.
  foreach (array('id') as $key) {
    $form[$key] = array(
      '#type' => 'value',
      '#value' => isset($tab->$key) ? $tab->$key : NULL,
    );
  }
  // Changed must be sent to the client, for later overwrite error checking.

  // If the node type has a title, and the node type form defined no special
  // weight for it, we default to a weight of -5 for consistency.
  if (isset($form['title']) && !isset($form['title']['#weight'])) {
    $form['title']['#weight'] = -5;
  }

  $form['additional_settings'] = array(
    '#type' => 'vertical_tabs',
    '#weight' => 99,
  );

   $form['upload'] = array(

      '#type' => 'file',

      '#title' => t('Upload tab control files'),

      '#size' => '100%',
);


  $form['name'] = array(

  '#type' => 'textfield',

  '#title' => t('Tab control name'),

  '#default_value' => $tab->name,

  '#size' => 60,

  '#maxlength' => 128,
      '#description' => t('Please make sure that the "Tab control name" value matches
                        the value in the "Compiled Javascript Project" property of the Likno Web Tabs Builder project file
                        (Tools > Project Properties > Folders). <a href="#" id="lwtb_show_me_toggle">show me</a>'.
			'<div style="text-align: center; max-width: 800px; margin-top: 20px; display: none; background-color: #FEFCF5; border: #E6DB55 solid 1px; padding: 10px 0;" id="lwtb_show_this">'.
			'		<strong>More info</strong> - <a href="#" class="lwtb_show_me_close">close</a>
                                        <br />
                                        <br />

						
							<img src="'.$base_url.'/'.drupal_get_path('module', 'likno_tabs').'/tabsname.jpg" alt="Project Name" title="Project Name"/>
                                                        <br />
                                                        <br />
                                                        Compiled Javascript Project(see <span style="color: red;">1</span>) and tab control name (see <span style="color: red;">2</span>) must be the same
                                                        <br />
                                                        <br />
                    <img src="'.$base_url.'/'.drupal_get_path('module', 'likno_tabs').'/tabsnamesec.jpg" alt="tab Name" title="tab control Name"/>
						
                                                            <br />
                                                            <br />
							<a href="#" class="lwtb_show_me_close">close</a>
				</div>'),


);
  $lwtb_indic_text = ($tab->active == 1)? "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This tab control will appear in your site" : "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This tab control will NOT appear in your site";
  $lwtb_indic_color = ($tab->active == 1)? "green" : "red";

 $form['active'] = array(
    '#type' => 'checkbox',
    '#title' => 'Show (enabled) <i>'.
            $tab->name .
		  '</i> in site <span id="lwtb_indic_text">'.$lwtb_indic_text.'</span>',
    '#default_value' =>  0, //by default show the 1st menu? (YES)
      '#return_value' => 1,
  );

 if ($tab->active == 1 )
          $form['active']['#attributes']['checked'] = true;


  $form['print_div'] = array(
      '#type' => 'checkbox',
      '#title' => t("Print 'DIV' element"),
  );
  if ($tab->print_div == 1)
          $form['print_div']['#attributes']['checked'] = true;
  $form['printed_div'] = array(
      '#type' => 'item',
      '#title' => "A 'DIV' element will be produced with this id:",
      '#markup' => t('<input readonly type="text" id="lwtb_divname" value="lwtbAnchor-'.$tab->name.'"/>
                                                  <a class="button" id="lwtb_copy_button">Copy</a>'),
      '#states' => array(

      // Hide the settings when the cancel notify checkbox is disabled.

      'invisible' => array(

       'input[name="print_div"]' => array('checked' =>FALSE),
      ),
          ),
  );

  $form['position-container'] = array(
   '#type' => 'container',

 );
 $form['position-container']['position'] = array(
    '#type' => 'radios',
    '#title' => t('Please select positioning method of the tab control'),
    '#options' => array('shortcode' => t('Shortcode'),'block' => t('Block')),
     '#default_value' =>  $tab->position,
  );

 
 $form['position-container']['shortcode-notice'] = array(
   '#type' => 'item',
    '#title' => 'Shortcode',
    
    '#markup' => 'The tab control will be placed inside a page/article. <br />
        Use this shortcode to place it: '
         .
         '<input readonly type="text" id="lwtb_shortcode" value="[tabs:'.$tab->name.']"/>
                                                  <a class="button" id="lwtb_shortcode_button">Copy</a>',
      // Hide the settings when the cancel notify checkbox is disabled.
    '#states' => array(
      'invisible' => array(

       'input[name="position"]' => array('value' => "block"),
      ),
        )

 );

 $form['position-container']['block-notice'] = array(
   '#type' => 'item',
    '#title' => 'Block',
     '#markup' => 'The tab control will be placed as a block. Go to '.l('admin/structure/block', 'admin/structure/block') .' and you will find a block with the name of this tab control.' ,
     '#states' => array(
      // Hide the settings when the cancel notify checkbox is disabled.
      'invisible' => array(
       'input[name="position"]' => array('value' => "shortcode"),
      ),
          )
 );
  $form['actions'] = array('#type' => 'actions');
  $form['actions']['submit'] = array(
    '#type' => 'submit',
    '#access' => user_access('administer likno_tabs'),
    '#value' => t('Save'),
    '#weight' => 5,
    '#submit' => array('likno_tabs_form_submit'),
  );
  if (!empty($tab->id)) {
    $form['actions']['delete'] = array(
      '#type' => 'submit',
      '#value' => t('Delete'),
      '#weight' => 15,
      '#submit' => array('likno_tabs_form_delete_submit'),
    );
  }
  $form['actions']['back'] = array(
      '#type' => 'link',
              '#title' => 'Back to admin page',
      '#weight' => 25,
              '#href' => 'admin/settings/likno_tabs'
    );

  // This form uses a button-level #submit handler for the form's main submit
  // action. node_form_submit() manually invokes all form-level #submit handlers
  // of the form. Without explicitly setting #submit, Form API would auto-detect
  // node_form_submit() as submit handler, but that is the button-level #submit
  // handler for the 'Save' action. To maintain backwards compatibility, a
  // #submit handler is auto-suggested for custom node type modules.
  $form['#validate'][] = 'likno_tabs_form_validate';
  if (!isset($form['#submit']) && function_exists('likno_tabs_form_submit')) {
    $form['#submit'][] = 'likno_tabs_form_submit';
  }
  $form += array('#submit' => array());

  //field_attach_form('node', $node, $form, $form_state, $node->language);
  return $form;
}




/**
 * Module settings form.
 * callback function for likno_tabs_menu() in likno_tabs.module
 */
function likno_tabs_settings($form, $form_state) {
  if (isset($form_state['values']['operation']) && $form_state['values']['operation'] == 'delete') {
        return likno_tabs_multiple_delete_confirm($form, $form_state, array_filter($form_state['values']['tabs']));
  }
  //$form['filter'] = node_filter_form();
  //$form['#submit'][] = 'node_filter_form_submit';
  $form['admin'] = likno_tabs_admin_tabs();

  return $form;
}
function likno_tabs_multiple_delete_confirm($form, &$form_state, $tabs){
    
$form['tabs'] = array('#prefix' => '<ul>', '#suffix' => '</ul>', '#tree' => TRUE);
  // array_filter returns only elements with TRUE values
  foreach ($tabs as $id => $value) {
    $name = db_query('SELECT name FROM {lwtb_table} WHERE id = :id', array(':id' => $id))->fetchField();
    $form['tabs'][$id] = array(
      '#type' => 'hidden',
      '#value' => $id,
      '#prefix' => '<li>',
      '#suffix' => check_plain($name) . "</li>\n",
    );
  }
  $form['operation'] = array('#type' => 'hidden', '#value' => 'delete');
  $form['#submit'][] = 'likno_tabs_multiple_delete_confirm_submit';
  $confirm_question = format_plural(count($tabs),
                                  'Are you sure you want to delete this item?',
                                  'Are you sure you want to delete these items?');
  return confirm_form($form,
                    $confirm_question,
                    'admin/settings/likno_tabs', t('This action cannot be undone.'),
                    t('Delete'), t('Cancel'));
}

function likno_tabs_multiple_delete_confirm_submit($form, &$form_state) {
  if ($form_state['values']['confirm']) {
      likno_tabs_delete(array_keys($form_state['values']['tabs']));
    $count = count($form_state['values']['tabs']);
    watchdog('content', 'Deleted @count tabs.', array('@count' => $count));
    drupal_set_message(format_plural($count, 'Deleted 1 tab control.', 'Deleted @count tab controls.'));
  }
  $form_state['redirect'] = 'admin/settings/likno_tabs';
}


function likno_tabs_settings_submit($form, &$form_state){
    $path = $form_state['values']['lwtb_path'];
    if ($path[0] != "/")
        $path = "/" .$path;
    if ($path[strlen($path)-1] != "/")
        $path = $path."/";
    variable_set('lwtb_path',$path );
}


/**
 * Validate node_admin_nodes form submissions.
 *
 * Check if any nodes have been selected to perform the chosen
 * 'Update option' on.
 */
function likno_tabs_admin_tabs_validate($form, &$form_state) {
  // Error if there are no items to select.
  if (!is_array($form_state['values']['tabs']) || !count(array_filter($form_state['values']['tabs']))) {
    form_set_error('', t('No tab controls selected.'));
  }
}

/**
 * Process node_admin_nodes form submissions.
 *
 * Execute the chosen 'Update option' on the selected nodes.
 */
function likno_tabs_admin_tabs_submit($form, &$form_state) {
  $operations = module_invoke_all('tab_operations');
  $operation = $operations[$form_state['values']['operation']];
  // Filter out unchecked nodes
  $tabs = array_filter($form_state['values']['tabs']);
  if ($function = $operation['callback']) {
    // Add in callback arguments if present.
    if (isset($operation['callback arguments'])) {
      $args = array_merge(array($tabs), $operation['callback arguments']);
    }
    else {
      $args = array($tabs);
    }
    call_user_func_array($function, $args);

    cache_clear_all();
  }
  else {
    // We need to rebuild the form to go to a second step. For example, to
    // show the confirmation form for the deletion of nodes.
    $form_state['rebuild'] = TRUE;
  }
}


/**
 * Form builder: Builds the node administration overview.
 */
function likno_tabs_admin_tabs() {
    global $base_url;
  $admin_access = user_access('administer likno_tabs');
  $form = array();
  // Build the 'Update notice'
  if (variable_get('LWTB_Check_Show',TRUE)) {
				$LWTB_buildText = LWTB_check();
				if ( $LWTB_buildText != '' )
                                    {
                                    $form['update-area'] = array(
                                        '#type'=>'fieldset',
                                        '#title' => 'Update Notificiations'
                                    );
                                      $form['update-area']['update-notice'] = array(
                                          '#type'=>'item',
      '#prefix'=>'<div style="max-width: 800px; margin-top: 20px; margin-bottom: 15px; background-color: #FEFCF5; border: #E6DB55 solid 1px; padding: 10px 0;">',
      '#suffix'=>'</div>',
      '#markup'=>$LWTB_buildText);
                                      $form['update-area']['hide-not-submit'] = array(
       '#type' => 'submit',
       '#value' => t('Hide Notifications'),
        '#submit' => array('likno_tabs_system_hide_notifications') );


                                    }
				else variable_set('LWTB_Check_Show', FALSE);
			}

// Build the 'settings' form;
  $form['settings'] = array(
    '#type' => 'fieldset',
    '#title' => t('Settings'),
    '#attributes' => array('class' => array('container-inline')),
    '#access' => $admin_access,
  );

  // lwtb online folder
  $form['settings']['lwtb_path'] = array(
    '#type' => 'textarea',
    '#title' => t('Online folder for tab controls files'),
    '#default_value' =>  variable_get('lwtb_path', "/". drupal_get_path('module', 'likno_tabs')."/files/"),
    '#cols' => 10,
    '#rows' => 1,
    '#description' => t('Every time you compile your Likno Web Tabs Builder project you should also upload the produced ZIP file online (see above). Its content (tab control files) are then automatically added by the plugin to this folder '.
                                                $base_url.'<span id="lwtb_the_path">'. variable_get('lwtb_path', "/".drupal_get_path('module', 'likno_tabs')."/files/") .'</span>'.
                                                '<br>(note: you might need to create this online folder yourself)'),
  );

   $form['settings']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('likno_tabs_settings_submit'),
  );
 // Build the 'Update options' form.
  $form['options'] = array(
    '#type' => 'fieldset',
    '#title' => t('Update options'),
    '#attributes' => array('class' => array('container-inline')),
    '#access' => $admin_access,
  );
    $options = array();
  foreach (module_invoke_all('tab_operations') as $operation => $array) {
    $options[$operation] = $array['label'];
  }
  $form['options']['operation'] = array(
    '#type' => 'select',
    '#title' => t('Operation'),
    '#title_display' => 'invisible',
    '#options' => $options,
    '#default_value' => 'approve',
  );
  $form['options']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Update'),
    '#validate' => array('likno_tabs_admin_tabs_validate'),
    '#submit' => array('likno_tabs_admin_tabs_submit'),
  );



  // Build the sortable table header.
  $header = array(
    'name' => array('data' => t('Name'), 'field' => 'a.name'),
    'position' => array('data' => t('Position'), 'field' => 'a.position'),
    'active' => array('data' => t('Active'), 'field' => 'a.active'),
  );
  $header['operations'] = array('data' => t('Operations'));

  $query = db_select('lwtb_table', 'a')->extend('PagerDefault')->extend('TableSort');
  //node_build_filter_query($query);

  $tabs = $query
    ->fields('a',array('id','name','position','active'))
    ->limit(50)
    ->orderByHeader($header)
    ->execute();

  $destination = drupal_get_destination();
  $options = array();
  foreach ($tabs as $tab) {
   
    $options[$tab->id] = array(
      'name' => array(
        'data' => array( 
          '#type' => 'link',
          '#title' => $tab->name,
          '#href' => 'admin/settings/likno_tabs/' . $tab->id . '/edit',
          #query' => $destination
        ),
      ),
      'position' => $tab->position,
      'active' => ($tab->active)?"<span style='color: green'>YES</span>":"<span style='color: red'>NO</span>",
      
    );
    // Build a list of all the accessible operations for the current node.
    $operations = array();
    
      $operations['edit'] = array(
        'title' => t('edit'),
        'href' => 'admin/settings/likno_tabs/' . $tab->id . '/edit',
        //'query' => $destination,
      );
    

      $operations['delete'] = array(
        'title' => t('delete'),
        'href' => 'admin/settings/likno_tabs/' . $tab->id . '/delete',
        'query' => $destination,
      );
    
    $options[$tab->id]['operations'] = array();
    if (count($operations) > 1) {
      // Render an unordered list of operations links.
      $options[$tab->id]['operations'] = array(
        'data' => array(
          '#theme' => 'links__node_operations',
          '#links' => $operations,
          '#attributes' => array('class' => array('links', 'inline')),
        ),
      );
    }
    elseif (!empty($operations)) {
      // Render the first and only operation as a link.
      $link = reset($operations);
      $options[$tab->id]['operations'] = array(
        'data' => array(
          '#type' => 'link',
          '#title' => $link['title'],
          '#href' => $link['href'],
          '#options' => array('query' => $link['query']),
        ),
      );
    }
  }

  // Only use a tableselect when the current user is able to perform any
  // operations.
  if ($admin_access) {
    $form['tabs'] = array(
      '#type' => 'tableselect',
      '#header' => $header,
      '#options' => $options,
      '#empty' => t('No content available.'),
    );
  }
  // Otherwise, use a simple table.
 

  $form['pager'] = array('#markup' => theme('pager'));
  return $form;
}

function likno_tabs_form_validate($form, &$form_state) {
  // $form_state['node'] contains the actual entity being edited, but we must
  // not update it with form values that have not yet been validated, so we
  // create a pseudo-entity to use during validation.
    $tab = (object) $form_state['values'];
    if (empty($tab->name)) {
    // The use of empty() is mandatory in the context of usernames
    // as the empty string denotes the anonymous user. In case we
    // are dealing with an anonymous user we set the user ID to 0.
        form_set_error('name', 'Name cannot be empty');
    
  }
  else if ((isset($tab->id) && db_query("SELECT name FROM {lwtb_table} WHERE name = :name and id !=:id", array(  ':name' => $tab->name, ':id'=>$tab->id))->rowCount()>0) || (!isset($tab->id) && db_query("SELECT name FROM {lwtb_table} WHERE name = :name ", array(  ':name' => $tab->name))->rowCount()>0)){
  form_set_error('name', t('There is another tab control with name: %name.', array('%name' => $tab->name)));
  }
}
function likno_tabs_form_delete_submit($form, &$form_state){

    $destination = array();
  if (isset($_GET['destination'])) {
    $destination = drupal_get_destination();
    unset($_GET['destination']);
  }
  $tab = (object) $form_state['values'];
  $form_state['redirect'] = array('admin/settings/likno_tabs/'.$tab->id.'/delete', array('query' => $destination));


}

/**
 * Delete multiple tabs.
 *
 * @param $ids
 *   An array of node IDs.
 */
function likno_tabs_delete($ids) {
  $transaction = db_transaction();
  if (!empty($ids)) {
    try {
      // Delete after calling hooks so that they can query node tables as needed.
      db_delete('lwtb_table')
        ->condition('id', $ids, 'IN')
        ->execute();
         }
    catch (Exception $e) {
      $transaction->rollback();
      watchdog_exception('node', $e);
      throw $e;
    }

  }
}


/**
 * Menu callback -- ask for confirmation of node deletion
 */
function likno_tabs_delete_confirm($form, &$form_state, $tab) {
  $form['#tab'] = $tab;
  // Always provide entity id in the same form key as in the entity edit form.
  $form['id'] = array('#type' => 'value', '#value' => $tab->id);
  return confirm_form($form,
    t('Are you sure you want to delete %name?', array('%name' => $tab->name)),
    'admin/settings/likno_tabs/' . $tab->id."/edit",
    t('This action cannot be undone.'),
    t('Delete'),
    t('Cancel')
  );
}

/**
 * Execute node deletion
 */
function likno_tabs_delete_confirm_submit($form, &$form_state) {
  if ($form_state['values']['confirm']) {
    $tab = tab_load($form_state['values']['id']);
    likno_tabs_delete(array($form_state['values']['id']));
    drupal_set_message(t('Tab control %name has been deleted.', array( '%name' => $tab->name)));
  }

  $form_state['redirect'] = 'admin/settings/likno_tabs';
}


function likno_tabs_form_submit($form, &$form_state) {

  $tab = new stdClass();

    $tab->id = $form_state['values']['id'];
    $tab->name = $form_state['values']['name'];
    $tab->active = $form_state['values']['active'];
    $tab->print_div = $form_state['values']['print_div'];
    $tab->position = $form_state['values']['position'];

  $insert = empty($tab->id);
  tab_save($tab);
  drupal_theme_rebuild();
  if ($insert) {
    drupal_set_message(t('Tab control '.$tab->name.' has been created.'));
  }
  else {
   drupal_set_message(t('Tab control '.$tab->name.' has been updated.'));
  }
  if ($tab->id) {
    $form_state['values']['id'] = $tab->id;
    $form_state['id'] = $tab->id;
    $form_state['redirect'] = 'admin/settings/likno_tabs';
    if ($_FILES['files']['size']['upload']){
        $limits = array ( 'extensions' => "zip", 'filename' => $tab->name ) ;
        $validators = array('file_validate_extensions' => array($limits['extensions']),'likno_tabs_validate_filename' => array($limits['filename'] ) );
        $file = file_save_upload('upload', $validators, false,FILE_EXISTS_REPLACE);

    }
    else{
        cache_clear_all();
        return;
    }
    if (isset($file) && $file == false ){
        $errors = form_get_errors();
         drupal_set_message(t('Error uploading file'),'error' );
         $form_state['rebuild'] = TRUE;
            cache_clear_all();
         return;
    }


    $path = ".".variable_get('lwtb_path', "/". drupal_get_path('module', 'likno_tabs')."/files/");

    if (file_prepare_directory($path, FILE_MODIFY_PERMISSIONS | FILE_CREATE_DIRECTORY)){

        if (!likno_tabs_unzipper(drupal_realpath($file->destination),$path)){
            drupal_set_message(t("Error unzipping file."),'error');
            $form_state['rebuild'] = TRUE;
        cache_clear_all();
            return;
        }
    }
    else{
        drupal_set_message(t("Check if folder ".variable_get('lwtb_path', "/". drupal_get_path('module', 'likno_tabs')."/files/")." exists and if it is writable"),'error');
        $form_state['rebuild'] = TRUE;
        cache_clear_all();
        return;
    }


  }
  else {
    // In the unlikely case something went wrong on save, the node will be
    // rebuilt and node form redisplayed the same way as in preview.
    drupal_set_message(t('The tab control could not be saved.'), 'error');
    $form_state['rebuild'] = TRUE;
  }
  // Clear the page and block caches.
  $form_state['redirect'] = 'admin/settings/likno_tabs';
  cache_clear_all();


}

/**
 * Save changes to a node or add a new node.
 *
 * @param $node
 *   The $node object to be saved. If $node->nid is
 *   omitted (or $node->is_new is TRUE), a new node will be added.
 */
function tab_save($tab) {
  $transaction = db_transaction();

  try {
    global $user;

    $update_tab = TRUE;
    // Save the node and node revision.
    if (empty($tab->id)) {
      // For new nodes, save new records for both the node itself and the node
      // revision.
      drupal_write_record('lwtb_table', $tab);
      $op = 'insert';
    }
    else {
      drupal_write_record('lwtb_table', $tab, 'id');


      $op = 'update';
    }

    db_ignore_slave();
  }
  catch (Exception $e) {
    $transaction->rollback();
    throw $e;
  }
}

function likno_tabs_system_hide_notifications(){
    cache_clear_all();
    variable_set('LWTB_Check_Show', FALSE);
    drupal_theme_rebuild();
    return;

}
